﻿String.prototype.startsWith = function (str) {
    return this.substr(0, str.length) == str;
};

String.prototype.contains = function (str) {
    return this.indexOf(str) !== -1;
};

function removeByClass(cn) {
    var el = document.getElementsByClassName(cn);
    while (el.length > 0) {
        el[0].parentNode.removeChild(el[0]);
    }
}

var pageAudit = {

// Display panels

    LinksAll: null,
    Report: null,
    Running: null,
    Dash: null,
    ErrorsNumber: null,
    ErrorsPercent: null,
    BeingScanned: null,
    LinksBroken: null,
    ShowMore: null,

//Running count variablea

    TotalLinks: 0,
    TestedLinks: 0,
    PendingLinks: 0,
    BrokenLinks: 0,

    // Settings
    // Collection of black list urls
    Blacklist: null,
    NoFollow: true,

    IsInitialized: false,
    Init: function () {
        if (!pageAudit.IsInitialized)
            chrome.extension.onMessage.addListener(pageAudit.SetupAudit);
        pageAudit.IsInitialized = true;
    },
    // Clear previous run
    Close: function () {
        removeByClass("L34N-brokenlink-checker");
    },
    SetupAudit: function (request, sender) {
        // Clear the Previous Run
        pageAudit.Close();

        // Read Settings
        pageAudit.Blacklist = request.bl.split("\n");

        // Init
        pageAudit.LinksAll = document.querySelectorAll('a');

        pageAudit.TotalLinks = pageAudit.LinksAll.length;
        pageAudit.TestedLinks = 0;
        pageAudit.PendingLinks = 0;
        pageAudit.BrokenLinks = 0;

        // Add Font links
        //<link href="https://fonts.googleapis.com/css?family=Roboto:regular,bold,italic,thin,light,bolditalic,black,medium&lang=en" rel="stylesheet">
        var robotoLinkUrl = document.createElement("link");
        robotoLinkUrl.setAttribute("rel", "stylesheet");
        robotoLinkUrl.setAttribute("href", "https://fonts.googleapis.com/css?family=Roboto:regular,bold,italic,thin,light,bolditalic,black,medium&lang=en");
        document.getElementsByTagName("head")[0].appendChild(robotoLinkUrl);

        //<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
        //var materialLinkUrl = document.createElement("link");
        //materialLinkUrl.setAttribute("rel", "stylesheet");
        //materialLinkUrl.setAttribute("href", "https://fonts.googleapis.com/icon?family=Material+Icons");
        //document.getElementsByTagName("head")[0].appendChild(materialLinkUrl);

        // Add Css
        var cssLink = document.createElement("link");
        cssLink.setAttribute("rel", "stylesheet");
        cssLink.setAttribute("type", "text/css");
        cssLink.setAttribute("href", chrome.extension.getURL("css/main.css"));
        document.getElementsByTagName("head")[0].appendChild(cssLink);

        // Create Report Template
        pageAudit.Report = document.createElement("div");
        pageAudit.Report.setAttribute("class", "L34N-brokenlink-checker");

        document.getElementsByTagName("body")[0].appendChild(pageAudit.Report);

        function OnPopupContentLoaded() {
            pageAudit.Report.innerHTML = loadPopupContentRequest.responseText;

            pageAudit.Running = document.getElementById("loadingProgressG");

            pageAudit.Dash = document.getElementById("L34N-brokenlink-dashboard-section");
            pageAudit.DashboardTotalNode = document.getElementById("L34N-brokenlink-total");
            pageAudit.ErrorsNumber = document.getElementById("L34N-brokenlink-errors");
            pageAudit.ErrorsPercent = document.getElementById("L34N-brokenlink-errorspercent");
            pageAudit.BeingTested = document.getElementById("link-being-tested");



            pageAudit.LinksBroken = document.getElementById("L34N-brokenlink-links-section");
            pageAudit.ShowMore = document.getElementById("L34N-brokenlink-viewmore");

            pageAudit.ShowMore.addEventListener('click', function () {
                var brokenLinks = pageAudit.LinksBroken.getElementsByClassName("hidden");
                while (brokenLinks.length > 0) {
                    brokenLinks[0].classList.remove('hidden');
                }
                pageAudit.ShowMore.classList.add('hidden');
            });

            pageAudit.Report.getElementsByClassName("close")[0].addEventListener('click', function () { pageAudit.Close(); });

            pageAudit.DoAudit();
        };

        var popupTemplateUrl = chrome.extension.getURL("popup.html");

        var loadPopupContentRequest = new XMLHttpRequest();
        loadPopupContentRequest.onload = OnPopupContentLoaded;
        loadPopupContentRequest.open("GET", popupTemplateUrl, true);
        loadPopupContentRequest.send();

    },

    DoAudit: function () {
        // Run through links, add feedback classes and ignore empty href and non http* links
        for (var i = 0; i < pageAudit.LinksAll.length; i++) {


            var link = pageAudit.LinksAll[i];
            var url = link.href;
            var rel = link.rel;
            blacklisted = false;




            if ((url.length <= 0) || (pageAudit.NoFollow === false && rel == "nofollow") || (url.startsWith('http') === false) || url.includes("%7B%7B")) {
                if (url.startsWith('chrome-extension://')) {

                }
                else {
                    console.log("Skipped: " + url);
                    //totalvalid -= 1;
                }
            }
            else {
                for (var b = 0; b < pageAudit.Blacklist.length; b++) {
                    if (pageAudit.Blacklist[b] !== "" && url.contains(pageAudit.Blacklist[b])) {
                        blacklisted = true;
                    }
                }

                if (blacklisted === true) {
                    console.log("Skipped (blacklisted): " + url);
                    //totalvalid -= 1;
                }
                else {
                    if (url.indexOf("#") == url.length - 1) {
                        //totalvalid -= 1;
                    }
                    else {
                        pageAudit.PendingLinks += 1;
                        link.classList.add("atom_link");
                        pageAudit.CheckURL(url, link);
                    }
                }
            }
        }
    },

    CheckURL: function (url, link) {

        
        
        chrome.extension.sendMessage({ "action": "check", "url": url },
         function (response) {
             pageAudit.UpdateDisplay(url, link, response);
         });
    },
    BrokenLinkIdIndex: 0,
    UpdateDisplay: function (url, link, response) {
        pageAudit.BeingTested.innerHTML = "<a href='" + url + "'>" + link.childNodes[0].nodeValue + "</a>";
        if (response) {
            if (200 <= response && response < 400) {
                link.classList.add("atom_valid");
            }
            else {
                console.log("Response " + response + ": " + url);
                var brokenLinkId = "atom_broken_id_" + pageAudit.BrokenLinkIdIndex++;
                link.classList.add("atom_broken");
                link.innerHTML += "<span id='" +brokenLinkId+ "' class='atom_response'>" + response + "</span>";
                pageAudit.BrokenLinks += 1;
                pageAudit.ErrorsNumber.innerHTML = pageAudit.BrokenLinks;
                if (pageAudit.TestedLinks != 0)
                    pageAudit.ErrorsPercent.innerHTML = Math.ceil((pageAudit.BrokenLinks * 100) / pageAudit.TestedLinks);

                if (pageAudit.BrokenLinks == 1) {
                    pageAudit.Dash.classList.remove('__success');
                    pageAudit.LinksBroken.classList.remove('hidden');
                }
                var li = document.createElement("li");
                if (pageAudit.BrokenLinks > 5)
                    li.classList.add('hidden');
                li.innerHTML = "<a onclick='document.getElementById(\"" + brokenLinkId + "\").scrollIntoView(true);' title='Scroll into view'><img class='L34N-brokenlink-scroll-into-view' src='" + chrome.extension.getURL("img/find_in_page.png") + "'/></a>" + "&nbsp;" + "<a class='linkTypeA' target='_blank' href='" + url + "' title='" + url + "|" + response + "'>" + link.childNodes[0].nodeValue + "</a>" + "&nbsp" + "<a target='_blank' class='button' href='https://intranet.secure.griffith.edu.au/computing/portals-and-search-support/contact-us/broken-link?brokenlink=true" + "&error-code=" + response + "&link-text=" + link.childNodes[0].nodeValue + "&link-url=" + encodeURIComponent(url) + "&page-url=" + encodeURIComponent(document.URL) + "'" + " title='Submit to Portals and Search team as a " + response + " error'>Report " + response + " error</a>";
                pageAudit.LinksBroken.getElementsByTagName("ul")[0].appendChild(li);

                if (pageAudit.BrokenLinks > 5) {
                    pageAudit.ShowMore.classList.remove('hidden');
                }
            }
            pageAudit.PendingLinks -= 1;
            pageAudit.TestedLinks += 1;
            pageAudit.DashboardTotalNode.innerHTML = pageAudit.TestedLinks;

            if (pageAudit.PendingLinks == 0) {

            pageAudit.BeingTested.classList.add('hidden');

                pageAudit.Running.classList.add('hidden');
                chrome.extension.onMessage.removeListener(pageAudit.SetupAudit);
            }
        }


        
    }
};

pageAudit.Init();
