var checkType;
var blacklistDefaults =
        "googleleads.g.doubleclick.net\n" +
        "doubleclick.net\n" +
        "googleadservices.com\n" +
        "www.googleadservices.com\n" +
        "googlesyndication.com\n" +
        "adservices.google.com\n" +
        "an.yandex.ru\n" +
        "appliedsemantics.com";

var checkTypeDefault = "GET";
var cacheDefault = "false";
var noFollowDefault = "false";

chrome.extension.onMessage.addListener(onRequest);

chrome.browserAction.onClicked.addListener(function (tab) {
    // Inject Styles and Elements for feedback report
    chrome.tabs.executeScript(tab.id, { file: 'linkchecker.js' }, function () {

        chrome.tabs.sendMessage(tab.id, { bl: blacklistDefaults });
    });
});

function onRequest(request, sender, callback) {
    if (request.action == "check") {
        if (request.url) {
            // do not use cache
            check(request.url, callback);
        }
    }
    return true;
}

// Timeout for each link is 60+1 seconds
var timeout = 30000;

function check(url, callback) {
    var XMLHttpTimeout = null;
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function (data) {
        if (xhr.readyState == 4) {
            console.log(xhr);
            clearTimeout(XMLHttpTimeout);
            if (200 <= xhr.status && xhr.status < 400) {
                // If there is a hashtag in the URL
                if (url.indexOf("#") != -1) {
                    var parser = new DOMParser();
                    var responseDoc = parser.parseFromString(xhr.responseText, "text/html");
                    var fragID = url.substring(url.indexOf("#") + 1, url.length);
                    console.log(responseDoc.getElementById(fragID) || responseDoc.getElementsByName(fragID));
                    if (responseDoc.getElementById(fragID) || responseDoc.getElementsByName(fragID).length > 0) {
                        return callback(xhr.status);
                    }
                    else {
                        // Page resolved, but element with id that matches hashtag was not found
                        return callback(404);
                    }
                }
                else {
                    // No hashtag
                }
            }
            return callback(xhr.status);
        }
    };

    try {
        xhr.open("GET", url, true);
        xhr.send();
    }
    catch (e) {
        console.log(e);
    }

    XMLHttpTimeout = setTimeout(function () { return callback(408); xhr.abort(); }, timeout += 10000);
}


function log(txt) {
alert("log");
}
